TypeKindVisitor7 (Java SE 22 & JDK 22)
Description: declaration: module: java.compiler, package: javax.lang.model.util, class: TypeKindVisitor7
Keywords: javax.lang.model.util.TypeKindVisitor7 class

Module java.compiler
Package javax.lang.model.util

# Class TypeKindVisitor7<R,P>

java.lang.Object
javax.lang.model.util.AbstractTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor6<R,P>
javax.lang.model.util.TypeKindVisitor6<R,P>
javax.lang.model.util.TypeKindVisitor7<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `TypeVisitor<R,P>`

Direct Known Subclasses:
  `TypeKindVisitor8`

@SupportedSourceVersion(RELEASE_7) public class TypeKindVisitor7<R,P> extends TypeKindVisitor6<R,P>
A visitor of types based on their kind with default behavior appropriate for the `RELEASE_7` source version. For types `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  1.7
See Also:
  - Compatibility note for subclasses
  - `TypeKindVisitor6`
  - `TypeKindVisitor8`
  - `TypeKindVisitor9`
  - `TypeKindVisitor14`

- ## Field Summary

  ### Fields declared in class javax.lang.model.util.SimpleTypeVisitor6

  `DEFAULT_VALUE`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `TypeKindVisitor7()`
  Deprecated.
  Release 7 is obsolete; update to a visitor for a newer release level.
  `protected`
  `TypeKindVisitor7(R defaultValue)`
  Deprecated.
  Release 7 is obsolete; update to a visitor for a newer release level.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `R`
  `visitUnion(UnionType t, P p)`
  Visits a union type.

  ### Methods declared in class javax.lang.model.util.TypeKindVisitor6

  `visitNoType, visitNoTypeAsModule, visitNoTypeAsNone, visitNoTypeAsPackage, visitNoTypeAsVoid, visitPrimitive, visitPrimitiveAsBoolean, visitPrimitiveAsByte, visitPrimitiveAsChar, visitPrimitiveAsDouble, visitPrimitiveAsFloat, visitPrimitiveAsInt, visitPrimitiveAsLong, visitPrimitiveAsShort`

  ### Methods declared in class javax.lang.model.util.SimpleTypeVisitor6

  `defaultAction, visitArray, visitDeclared, visitError, visitExecutable, visitNull, visitTypeVariable, visitWildcard`

  ### Methods declared in class javax.lang.model.util.AbstractTypeVisitor6

  `visit, visit, visitIntersection, visitUnknown`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TypeKindVisitor7

    @Deprecated(since="12") protected TypeKindVisitor7()
    Deprecated.
    Release 7 is obsolete; update to a visitor for a newer release level.
    Constructor for concrete subclasses to call; uses `null` for the default value.

  - ### TypeKindVisitor7

    @Deprecated(since="12") protected TypeKindVisitor7(R defaultValue)
    Deprecated.
    Release 7 is obsolete; update to a visitor for a newer release level.
    Constructor for concrete subclasses to call; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleTypeVisitor6.DEFAULT_VALUE`

- ## Method Details

  - ### visitUnion

    public R visitUnion(UnionType t, P p)
    Visits a union type.
    Specified by:
      `visitUnion` in interface `TypeVisitor<R,P>`
    Overrides:
      `visitUnion` in class `AbstractTypeVisitor6<R,P>`
    Implementation Requirements:
      This implementation calls `defaultAction`.
    Parameters:
      `t` - the type to visit
      `p` - a visitor-specified parameter
    Returns:
      the result of `defaultAction`